# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.table_algorithm import TableAlgorithm


class ExtractExodusGlobalTemporalVariables(TableAlgorithm):
    """
    ExtractExodusGlobalTemporalVariables - extract global temporal
    arrays generated by ExodusIIReader
    
    Superclass: TableAlgorithm
    
    ExtractExodusGlobalTemporalVariables is intended to extract global
    temporal arrays generated by ExodusIIReader.
    
    Global temporal variables are special arrays that have values per
    timestep. ExodusIIReader can read these values for all timestep
    and provide them easily, thus avoiding the need to read all timesteps
    to extract these values over timesteps. A slight complication is with
    para_view, where para_view supports what are referred to as restarts
    i.e. instead of a single file having all timesteps, the timesteps are
    arbitrarily split among multiple files. For such cases, this filter
    needs to iterate over all the files to accumulate the data. Since
    there's no information about files or ability to request the upstream
    reader to read a particular file, this filter request specific
    timesteps using some smarts to determine which timestep to request
    and not simply loop over all timesteps.
    
    @sa ExodusIIReader, ExodusIIReader::GLOBAL_TEMPORAL_VARIABLE.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkExtractExodusGlobalTemporalVariables, obj, update, **traits)
    
    _updateable_traits_ = \
    (('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('progress',
    'GetProgress'), ('progress_text', 'GetProgressText'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ExtractExodusGlobalTemporalVariables, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ExtractExodusGlobalTemporalVariables properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], []),
            title='Edit ExtractExodusGlobalTemporalVariables properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ExtractExodusGlobalTemporalVariables properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

