# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.non_linear_cell import NonLinearCell


class HigherOrderHexahedron(NonLinearCell):
    """
    HigherOrderHexahedron - A 3d cell that represents an arbitrary
    order higher_order hex
    
    Superclass: NonLinearCell
    
    HigherOrderHexahedron is a concrete implementation of Cell to
    represent a 3d hexahedron using higher_order shape functions of user
    specified order.
    
    @sa
    Hexahedron
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkHigherOrderHexahedron, obj, update, **traits)
    
    def get_order(self, *args):
        """
        V.get_order() -> (int, ...)
        C++: virtual const int *GetOrder()
        V.get_order(int) -> int
        C++: virtual int GetOrder(int i)"""
        ret = self._wrap_call(self._vtk_obj.GetOrder, *args)
        return ret

    def set_order(self, *args):
        """
        V.set_order(int, int, int)
        C++: virtual void SetOrder(const int s, const int t, const int u)"""
        ret = self._wrap_call(self._vtk_obj.SetOrder, *args)
        return ret

    parametric_coords = traits.Array(enter_set=True, auto_set=False, shape=(24,), dtype="float", value=(0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0, 1.0, 0.0, 1.0, 1.0, 1.0, 1.0, 0.0, 1.0, 1.0), cols=3, desc=\
        """
        
        """
    )

    def _parametric_coords_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetParametricCoords,
                        self.parametric_coords)

    def node_numbering_mapping_from_vtk8_to9(self, *args):
        """
        V.node_numbering_mapping_from_vtk8_to9((int, int, int), int) -> int
        C++: static IdType NodeNumberingMappingFromVTK8To9(
            const int order[3], const IdType node_id_Eight)"""
        ret = self._wrap_call(self._vtk_obj.NodeNumberingMappingFromVTK8To9, *args)
        return ret

    def point_index_from_ijk(self, *args):
        """
        V.point_index_from_ijk(int, int, int, (int, ...)) -> int
        C++: static int PointIndexFromIJK(int i, int j, int k,
            const int *order)
        V.point_index_from_ijk(int, int, int) -> int
        C++: int PointIndexFromIJK(int i, int j, int k)"""
        ret = self._wrap_call(self._vtk_obj.PointIndexFromIJK, *args)
        return ret

    def set_order_from_cell_data(self, *args):
        """
        V.set_order_from_cell_data(CellData, int, int)
        C++: virtual void SetOrderFromCellData(CellData *cell_data,
            const IdType numPts, const IdType cell_id)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetOrderFromCellData, *my_args)
        return ret

    def set_uniform_order_from_num_points(self, *args):
        """
        V.set_uniform_order_from_num_points(int)
        C++: virtual void SetUniformOrderFromNumPoints(
            const IdType numPts)"""
        ret = self._wrap_call(self._vtk_obj.SetUniformOrderFromNumPoints, *args)
        return ret

    def sub_cell_coordinates_from_id(self, *args):
        """
        V.sub_cell_coordinates_from_id(Vector3i, int) -> bool
        C++: bool SubCellCoordinatesFromId(Vector3i &ijk, int subId)
        V.sub_cell_coordinates_from_id(int, int, int, int) -> bool
        C++: bool SubCellCoordinatesFromId(int &i, int &j, int &k,
            int subId)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SubCellCoordinatesFromId, *my_args)
        return ret

    def transform_approx_to_cell_params(self, *args):
        """
        V.transform_approx_to_cell_params(int, [float, ...]) -> bool
        C++: bool TransformApproxToCellParams(int subCell,
            double *pcoords)"""
        ret = self._wrap_call(self._vtk_obj.TransformApproxToCellParams, *args)
        return ret

    def transform_face_to_cell_params(self, *args):
        """
        V.transform_face_to_cell_params(int, [float, ...]) -> bool
        C++: bool TransformFaceToCellParams(int bdyFace, double *pcoords)"""
        ret = self._wrap_call(self._vtk_obj.TransformFaceToCellParams, *args)
        return ret

    def get_edge_cell(self):
        """
        V.get_edge_cell() -> HigherOrderCurve
        C++: virtual HigherOrderCurve *getEdgeCell()"""
        ret = wrap_vtk(self._vtk_obj.getEdgeCell())
        return ret
        

    def get_face_cell(self):
        """
        V.get_face_cell() -> HigherOrderQuadrilateral
        C++: virtual HigherOrderQuadrilateral *getFaceCell()"""
        ret = wrap_vtk(self._vtk_obj.getFaceCell())
        return ret
        

    def get_interp(self):
        """
        V.get_interp() -> HigherOrderInterpolation
        C++: virtual HigherOrderInterpolation *getInterp()"""
        ret = wrap_vtk(self._vtk_obj.getInterp())
        return ret
        

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('parametric_coords',
    'GetParametricCoords'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'parametric_coords'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(HigherOrderHexahedron, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit HigherOrderHexahedron properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['parametric_coords']),
            title='Edit HigherOrderHexahedron properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit HigherOrderHexahedron properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

