# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class HigherOrderInterpolation(Object):
    """
    HigherOrderInterpolation
    
    Superclass: Object
    
    See Also:
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkHigherOrderInterpolation, obj, update, **traits)
    
    def get_edge_indices_bounding_hex_face(self, *args):
        """
        V.get_edge_indices_bounding_hex_face(int) -> (int, int, int, int)
        C++: static const int *GetEdgeIndicesBoundingHexFace(int faceId)"""
        ret = self._wrap_call(self._vtk_obj.GetEdgeIndicesBoundingHexFace, *args)
        return ret

    def get_edge_indices_bounding_wedge_face(self, *args):
        """
        V.get_edge_indices_bounding_wedge_face(int) -> (int, int, int, int)
        C++: static const int *GetEdgeIndicesBoundingWedgeFace(int faceId)"""
        ret = self._wrap_call(self._vtk_obj.GetEdgeIndicesBoundingWedgeFace, *args)
        return ret

    def get_fixed_parameter_of_hex_face(self, *args):
        """
        V.get_fixed_parameter_of_hex_face(int) -> int
        C++: static int GetFixedParameterOfHexFace(int faceId)"""
        ret = self._wrap_call(self._vtk_obj.GetFixedParameterOfHexFace, *args)
        return ret

    def get_fixed_parameter_of_wedge_face(self, *args):
        """
        V.get_fixed_parameter_of_wedge_face(int) -> int
        C++: static int GetFixedParameterOfWedgeFace(int faceId)"""
        ret = self._wrap_call(self._vtk_obj.GetFixedParameterOfWedgeFace, *args)
        return ret

    def get_fixed_parameters_of_hex_edge(self, *args):
        """
        V.get_fixed_parameters_of_hex_edge(int) -> Vector2i
        C++: static Vector2i GetFixedParametersOfHexEdge(int edgeId)"""
        ret = self._wrap_call(self._vtk_obj.GetFixedParametersOfHexEdge, *args)
        return wrap_vtk(ret)

    def get_fixed_parameters_of_wedge_edge(self, *args):
        """
        V.get_fixed_parameters_of_wedge_edge(int) -> Vector2i
        C++: static Vector2i GetFixedParametersOfWedgeEdge(int edgeId)"""
        ret = self._wrap_call(self._vtk_obj.GetFixedParametersOfWedgeEdge, *args)
        return wrap_vtk(ret)

    def get_parametric_hex_coordinates(self, *args):
        """
        V.get_parametric_hex_coordinates(int) -> Vector3d
        C++: static Vector3d GetParametricHexCoordinates(int vertexId)"""
        ret = self._wrap_call(self._vtk_obj.GetParametricHexCoordinates, *args)
        return wrap_vtk(ret)

    def get_parametric_wedge_coordinates(self, *args):
        """
        V.get_parametric_wedge_coordinates(int) -> Vector3d
        C++: static Vector3d GetParametricWedgeCoordinates(
            int vertexId)"""
        ret = self._wrap_call(self._vtk_obj.GetParametricWedgeCoordinates, *args)
        return wrap_vtk(ret)

    def get_point_indices_bounding_hex_edge(self, *args):
        """
        V.get_point_indices_bounding_hex_edge(int) -> Vector2i
        C++: static Vector2i GetPointIndicesBoundingHexEdge(int edgeId)"""
        ret = self._wrap_call(self._vtk_obj.GetPointIndicesBoundingHexEdge, *args)
        return wrap_vtk(ret)

    def get_point_indices_bounding_hex_face(self, *args):
        """
        V.get_point_indices_bounding_hex_face(int) -> (int, int, int, int)
        C++: static const int *GetPointIndicesBoundingHexFace(int faceId)"""
        ret = self._wrap_call(self._vtk_obj.GetPointIndicesBoundingHexFace, *args)
        return ret

    def get_point_indices_bounding_wedge_edge(self, *args):
        """
        V.get_point_indices_bounding_wedge_edge(int) -> Vector2i
        C++: static Vector2i GetPointIndicesBoundingWedgeEdge(
            int edgeId)"""
        ret = self._wrap_call(self._vtk_obj.GetPointIndicesBoundingWedgeEdge, *args)
        return wrap_vtk(ret)

    def get_point_indices_bounding_wedge_face(self, *args):
        """
        V.get_point_indices_bounding_wedge_face(int) -> (int, int, int, int)
        C++: static const int *GetPointIndicesBoundingWedgeFace(
            int faceId)"""
        ret = self._wrap_call(self._vtk_obj.GetPointIndicesBoundingWedgeFace, *args)
        return ret

    def get_varying_parameter_of_hex_edge(self, *args):
        """
        V.get_varying_parameter_of_hex_edge(int) -> int
        C++: static int GetVaryingParameterOfHexEdge(int edgeId)"""
        ret = self._wrap_call(self._vtk_obj.GetVaryingParameterOfHexEdge, *args)
        return ret

    def get_varying_parameter_of_wedge_edge(self, *args):
        """
        V.get_varying_parameter_of_wedge_edge(int) -> int
        C++: static int GetVaryingParameterOfWedgeEdge(int edgeId)"""
        ret = self._wrap_call(self._vtk_obj.GetVaryingParameterOfWedgeEdge, *args)
        return ret

    def get_varying_parameters_of_hex_face(self, *args):
        """
        V.get_varying_parameters_of_hex_face(int) -> Vector2i
        C++: static Vector2i GetVaryingParametersOfHexFace(int faceId)"""
        ret = self._wrap_call(self._vtk_obj.GetVaryingParametersOfHexFace, *args)
        return wrap_vtk(ret)

    def get_varying_parameters_of_wedge_face(self, *args):
        """
        V.get_varying_parameters_of_wedge_face(int) -> Vector2i
        C++: static Vector2i GetVaryingParametersOfWedgeFace(
            int faceId)"""
        ret = self._wrap_call(self._vtk_obj.GetVaryingParametersOfWedgeFace, *args)
        return wrap_vtk(ret)

    def append_curve_collocation_points(self, *args):
        """
        V.append_curve_collocation_points(SmartPointer_I9vtkPointsE, (int)
            )
        C++: static void AppendCurveCollocationPoints(
            SmartPointer<vtkPoints> &pts, const int order[1])"""
        my_args = deref_array(args, [('vtkSmartPointer_I9vtkPointsE', 'int')])
        ret = self._wrap_call(self._vtk_obj.AppendCurveCollocationPoints, *my_args)
        return ret

    def append_hexahedron_collocation_points(self, *args):
        """
        V.append_hexahedron_collocation_points(SmartPointer_I9vtkPointsE,
            (int, int, int))
        C++: static void AppendHexahedronCollocationPoints(
            SmartPointer<vtkPoints> &pts, const int order[3])"""
        my_args = deref_array(args, [('vtkSmartPointer_I9vtkPointsE', ('int', 'int', 'int'))])
        ret = self._wrap_call(self._vtk_obj.AppendHexahedronCollocationPoints, *my_args)
        return ret

    def append_quadrilateral_collocation_points(self, *args):
        """
        V.append_quadrilateral_collocation_points(
            SmartPointer_I9vtkPointsE, (int, int))
        C++: static void AppendQuadrilateralCollocationPoints(
            SmartPointer<vtkPoints> &pts, const int order[2])"""
        my_args = deref_array(args, [('vtkSmartPointer_I9vtkPointsE', ('int', 'int'))])
        ret = self._wrap_call(self._vtk_obj.AppendQuadrilateralCollocationPoints, *my_args)
        return ret

    def append_wedge_collocation_points(self, *args):
        """
        V.append_wedge_collocation_points(SmartPointer_I9vtkPointsE, (int,
             int, int))
        C++: static void AppendWedgeCollocationPoints(
            SmartPointer<vtkPoints> &pts, const int order[3])"""
        my_args = deref_array(args, [('vtkSmartPointer_I9vtkPointsE', ('int', 'int', 'int'))])
        ret = self._wrap_call(self._vtk_obj.AppendWedgeCollocationPoints, *my_args)
        return ret

    def tensor3_evaluate_derivative(self, *args):
        """
        V.tensor3_evaluate_derivative((int, int, int), (float, ...),
            Points, (float, ...), int, [float, ...])
        C++: virtual void Tensor3EvaluateDerivative(const int order[3],
            const double *pcoords, Points *points,
            const double *fieldVals, int fieldDim, double *fieldDerivs)"""
        my_args = deref_array(args, [(('int', 'int', 'int'), ('float', Ellipsis), 'vtkPoints', ('float', Ellipsis), 'int', 'tuple')])
        ret = self._wrap_call(self._vtk_obj.Tensor3EvaluateDerivative, *my_args)
        return ret

    def wedge_evaluate(self, *args):
        """
        V.wedge_evaluate((int, int, int), int, (float, ...), [float, ...],
            int, [float, ...])
        C++: virtual void WedgeEvaluate(const int order[3],
            const IdType numberOfPoints, const double *pcoords,
            double *fieldVals, int fieldDim, double *fieldAtPCoords)"""
        ret = self._wrap_call(self._vtk_obj.WedgeEvaluate, *args)
        return ret

    def wedge_evaluate_derivative(self, *args):
        """
        V.wedge_evaluate_derivative((int, int, int), (float, ...),
            Points, (float, ...), int, [float, ...])
        C++: virtual void WedgeEvaluateDerivative(const int order[3],
            const double *pcoords, Points *points,
            const double *fieldVals, int fieldDim, double *fieldDerivs)"""
        my_args = deref_array(args, [(('int', 'int', 'int'), ('float', Ellipsis), 'vtkPoints', ('float', Ellipsis), 'int', 'tuple')])
        ret = self._wrap_call(self._vtk_obj.WedgeEvaluateDerivative, *my_args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(HigherOrderInterpolation, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit HigherOrderInterpolation properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], []),
            title='Edit HigherOrderInterpolation properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit HigherOrderInterpolation properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

