# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class HyperTreeGridNonOrientedSuperCursor(Object):
    """
    HyperTreeGridNonOrientedSuperCursor - Objects for traversal a
    hyper_tree_grid.
    
    Superclass: Object
    
    JB A REVOIR Objects that can perform depth traversal of a hyper tree
    grid, take into account more parameters (related to the grid
    structure) than the compact hyper tree cursor implemented in
    HyperTree can. This is an abstract class. Cursors are created by
    the hyper_tree_grid implementation.
    
    @sa
    HyperTreeCursor HyperTree HyperTreeGrid
    
    @par Thanks: This class was written by Guenole Harel and
    Jacques-Bernard Lekien, 2014. This class was re-written by Philippe
    Pebay, 2016. This class was re-written and optimized by
    Jacques-Bernard Lekien, Guenole Harel and Jerome Dubois, 2018. This
    work was supported by Commissariat a l'Energie Atomique CEA, DAM,
    DIF, F-91297 Arpajon, France.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkHyperTreeGridNonOrientedSuperCursor, obj, update, **traits)
    
    def get_bounds(self, *args):
        """
        V.get_bounds([float, float, float, float, float, float])
        C++: void GetBounds(double bounds[6])
        V.get_bounds(int, [float, float, float, float, float, float])
        C++: void GetBounds(unsigned int icursor, double bounds[6])
        JB Coordonnees de la boite englobante
        """
        ret = self._wrap_call(self._vtk_obj.GetBounds, *args)
        return ret

    def _get_dimension(self):
        return self._vtk_obj.GetDimension()
    dimension = traits.Property(_get_dimension, desc=\
        """
        Return the dimension of the tree.
        \post positive_result: result>0
        """
    )

    def _get_global_node_index(self):
        return self._vtk_obj.GetGlobalNodeIndex()
    global_node_index = traits.Property(_get_global_node_index, desc=\
        """
        Return the global index (relative to the grid) of the current
        vertex in the tree.
        """
    )

    def get_global_node_index(self, *args):
        """
        V.get_global_node_index() -> int
        C++: IdType GetGlobalNodeIndex()
        V.get_global_node_index(int) -> int
        C++: IdType GetGlobalNodeIndex(unsigned int icursor)
        Return the global index (relative to the grid) of the current
        vertex in the tree.
        """
        ret = self._wrap_call(self._vtk_obj.GetGlobalNodeIndex, *args)
        return ret

    def _get_grid(self):
        return wrap_vtk(self._vtk_obj.GetGrid())
    grid = traits.Property(_get_grid, desc=\
        """
        Set the hyper tree grid to which the cursor is pointing.
        """
    )

    def get_information(self, *args):
        """
        V.get_information(int, int, bool, int) -> HyperTree
        C++: HyperTree *GetInformation(unsigned int icursor,
            unsigned int &level, bool &leaf, IdType &id)
        JB
        """
        ret = self._wrap_call(self._vtk_obj.GetInformation, *args)
        return wrap_vtk(ret)

    def _get_level(self):
        return self._vtk_obj.GetLevel()
    level = traits.Property(_get_level, desc=\
        """
        Get the level of the tree vertex pointed by the cursor.
        """
    )

    def get_level(self, *args):
        """
        V.get_level() -> int
        C++: unsigned int GetLevel()
        V.get_level(int) -> int
        C++: unsigned int GetLevel(unsigned int icursor)
        Get the level of the tree vertex pointed by the cursor.
        """
        ret = self._wrap_call(self._vtk_obj.GetLevel, *args)
        return ret

    def get_non_oriented_geometry_cursor(self, *args):
        """
        V.get_non_oriented_geometry_cursor(int)
            -> SmartPointer_I41vtkHyperTreeGridNonOrientedGeometryCursorE
        C++: SmartPointer<vtkHyperTreeGridNonOrientedGeometryCursor> GetNonOrientedGeometryCursor(
            unsigned int icursor)
        Return the cursor pointing into i-th neighbor. The neighborhood
        definition depends on the type of cursor. NB: Only super cursors
        keep track of neighborhoods.
        """
        ret = self._wrap_call(self._vtk_obj.GetNonOrientedGeometryCursor, *args)
        return wrap_vtk(ret)

    def _get_number_of_children(self):
        return self._vtk_obj.GetNumberOfChildren()
    number_of_children = traits.Property(_get_number_of_children, desc=\
        """
        Return the number of children for each node (non-vertex leaf) of
        the tree.
        \post positive_number: result>0
        """
    )

    def _get_number_of_cursors(self):
        return self._vtk_obj.GetNumberOfCursors()
    number_of_cursors = traits.Property(_get_number_of_cursors, desc=\
        """
        JB
        """
    )

    def get_oriented_geometry_cursor(self, *args):
        """
        V.get_oriented_geometry_cursor(int)
            -> SmartPointer_I38vtkHyperTreeGridOrientedGeometryCursorE
        C++: SmartPointer<vtkHyperTreeGridOrientedGeometryCursor> GetOrientedGeometryCursor(
            unsigned int icursor)
        Return the cursor pointing into i-th neighbor. The neighborhood
        definition depends on the type of cursor. NB: Only super cursors
        keep track of neighborhoods.
        """
        ret = self._wrap_call(self._vtk_obj.GetOrientedGeometryCursor, *args)
        return wrap_vtk(ret)

    def _get_origin(self):
        return self._vtk_obj.GetOrigin()
    origin = traits.Property(_get_origin, desc=\
        """
        JB
        """
    )

    def get_point(self, *args):
        """
        V.get_point([float, float, float])
        C++: void GetPoint(double point[3])
        V.get_point(int, [float, float, float])
        C++: void GetPoint(unsigned int icursor, double point[3])
        JB Coordonnees du centre de la maille
        """
        ret = self._wrap_call(self._vtk_obj.GetPoint, *args)
        return ret

    def _get_size(self):
        return self._vtk_obj.GetSize()
    size = traits.Property(_get_size, desc=\
        """
        
        """
    )

    def _get_tree(self):
        return wrap_vtk(self._vtk_obj.GetTree())
    tree = traits.Property(_get_tree, desc=\
        """
        Set the hyper tree to which the cursor is pointing.
        """
    )

    def get_tree(self, *args):
        """
        V.get_tree() -> HyperTree
        C++: HyperTree *GetTree()
        V.get_tree(int) -> HyperTree
        C++: HyperTree *GetTree(unsigned int icursor)
        Set the hyper tree to which the cursor is pointing.
        """
        ret = self._wrap_call(self._vtk_obj.GetTree, *args)
        return wrap_vtk(ret)

    def _get_vertex_id(self):
        return self._vtk_obj.GetVertexId()
    vertex_id = traits.Property(_get_vertex_id, desc=\
        """
        Return the index of the current vertex in the tree.
        """
    )

    def get_vertex_id(self, *args):
        """
        V.get_vertex_id() -> int
        C++: IdType GetVertexId()
        V.get_vertex_id(int) -> int
        C++: IdType GetVertexId(unsigned int icursor)
        Return the index of the current vertex in the tree.
        """
        ret = self._wrap_call(self._vtk_obj.GetVertexId, *args)
        return ret

    def clone(self):
        """
        V.clone() -> HyperTreeGridNonOrientedSuperCursor
        C++: virtual HyperTreeGridNonOrientedSuperCursor *Clone()
        Create a copy of `this'.
        \post results_exists:result!=0
        """
        ret = wrap_vtk(self._vtk_obj.Clone())
        return ret
        

    def has_tree(self, *args):
        """
        V.has_tree() -> bool
        C++: bool HasTree()
        V.has_tree(int) -> bool
        C++: bool HasTree(unsigned int icursor)
        Return if a Tree pointing exist
        """
        ret = self._wrap_call(self._vtk_obj.HasTree, *args)
        return ret

    def initialize(self, *args):
        """
        V.initialize(HyperTreeGrid, int, bool)
        C++: virtual void Initialize(HyperTreeGrid *grid,
            IdType treeIndex, bool create=false)
        Initialize cursor at root of given tree index in grid. JB Le
        create ne s'applique que sur le HT central.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.Initialize, *my_args)
        return ret

    def is_leaf(self, *args):
        """
        V.is_leaf() -> bool
        C++: bool IsLeaf()
        V.is_leaf(int) -> bool
        C++: bool IsLeaf(unsigned int icursor)
        Is the cursor pointing to a leaf?
        """
        ret = self._wrap_call(self._vtk_obj.IsLeaf, *args)
        return ret

    def is_masked(self, *args):
        """
        V.is_masked() -> bool
        C++: bool IsMasked()
        V.is_masked(int) -> bool
        C++: bool IsMasked(unsigned int icursor)
        Determine whether blanking mask is empty or not
        """
        ret = self._wrap_call(self._vtk_obj.IsMasked, *args)
        return ret

    def is_root(self):
        """
        V.is_root() -> bool
        C++: bool IsRoot()
        Is the cursor at tree root?
        """
        ret = self._vtk_obj.IsRoot()
        return ret
        

    def set_global_index_from_local(self, *args):
        """
        V.set_global_index_from_local(int)
        C++: void SetGlobalIndexFromLocal(IdType index)
        JB
        """
        ret = self._wrap_call(self._vtk_obj.SetGlobalIndexFromLocal, *args)
        return ret

    def set_global_index_start(self, *args):
        """
        V.set_global_index_start(int)
        C++: void SetGlobalIndexStart(IdType index)
        JB
        """
        ret = self._wrap_call(self._vtk_obj.SetGlobalIndexStart, *args)
        return ret

    def set_mask(self, *args):
        """
        V.set_mask(bool)
        C++: void SetMask(bool state)
        V.set_mask(int, bool)
        C++: void SetMask(unsigned int icursor, bool state)
        Set the blanking mask is empty or not
        \pre not_tree: tree
        """
        ret = self._wrap_call(self._vtk_obj.SetMask, *args)
        return ret

    def subdivide_leaf(self):
        """
        V.subdivide_leaf()
        C++: void SubdivideLeaf()
        JB Fait chier normalement on devrait passer par get_entry
        """
        ret = self._vtk_obj.SubdivideLeaf()
        return ret
        

    def to_child(self, *args):
        """
        V.to_child(int)
        C++: void ToChild(unsigned char ichild)
        Move the cursor to child `child' of the current vertex.
        \pre not_tree: has_tree()
        \pre not_leaf: !_is_leaf()
        \pre valid_child: ichild>=0 && ichild<_get_number_of_children()
        \pre depth_limiter: get_level() <= get_depth_limiter()
        """
        ret = self._wrap_call(self._vtk_obj.ToChild, *args)
        return ret

    def to_parent(self):
        """
        V.to_parent()
        C++: void ToParent()
        Move the cursor to the parent of the current vertex. Authorized
        if has_history return true.
        \pre Non_root: !_is_root()
        """
        ret = self._vtk_obj.ToParent()
        return ret
        

    def to_root(self):
        """
        V.to_root()
        C++: void ToRoot()
        Move the cursor to the root vertex.
        \pre can be root
        \post is_root: is_root()
        """
        ret = self._vtk_obj.ToRoot()
        return ret
        

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(HyperTreeGridNonOrientedSuperCursor, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit HyperTreeGridNonOrientedSuperCursor properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], []),
            title='Edit HyperTreeGridNonOrientedSuperCursor properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit HyperTreeGridNonOrientedSuperCursor properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

