# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class WebGLObject(Object):
    """
    WebGLObject - WebGLObject represent and manipulate an web_gl
    object and its data.
    
    Superclass: Object
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkWebGLObject, obj, update, **traits)
    
    id = traits.String('', enter_set=True, auto_set=False, desc=\
        """
        
        """
    )

    def _id_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetId,
                        self.id)

    layer = traits.Int(1886217556, enter_set=True, auto_set=False, desc=\
        """
        
        """
    )

    def _layer_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetLayer,
                        self.layer)

    renderer_id = traits.Int(504403158265495552, enter_set=True, auto_set=False, desc=\
        """
        
        """
    )

    def _renderer_id_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetRendererId,
                        self.renderer_id)

    def get_binary_data(self, *args):
        """
        V.get_binary_data(int) -> (int, ...)
        C++: virtual unsigned char *GetBinaryData(int part)
        V.get_binary_data(int, UnsignedCharArray)
        C++: void GetBinaryData(int part, UnsignedCharArray *buffer)"""
        my_args = deref_array(args, [['int'], ('int', 'vtkUnsignedCharArray')])
        ret = self._wrap_call(self._vtk_obj.GetBinaryData, *my_args)
        return ret

    def get_binary_size(self, *args):
        """
        V.get_binary_size(int) -> int
        C++: virtual int GetBinarySize(int part)"""
        ret = self._wrap_call(self._vtk_obj.GetBinarySize, *args)
        return ret

    def _get_md5(self):
        return self._vtk_obj.GetMD5()
    md5 = traits.Property(_get_md5, desc=\
        """
        
        """
    )

    def _get_number_of_parts(self):
        return self._vtk_obj.GetNumberOfParts()
    number_of_parts = traits.Property(_get_number_of_parts, desc=\
        """
        
        """
    )

    def generate_binary_data(self):
        """
        V.generate_binary_data()
        C++: virtual void GenerateBinaryData()"""
        ret = self._vtk_obj.GenerateBinaryData()
        return ret
        

    def has_changed(self):
        """
        V.has_changed() -> bool
        C++: bool HasChanged()"""
        ret = self._vtk_obj.HasChanged()
        return ret
        

    def has_transparency(self):
        """
        V.has_transparency() -> bool
        C++: bool HasTransparency()"""
        ret = self._vtk_obj.HasTransparency()
        return ret
        

    def interact_at_server(self):
        """
        V.interact_at_server() -> bool
        C++: bool InteractAtServer()"""
        ret = self._vtk_obj.InteractAtServer()
        return ret
        

    def set_has_transparency(self, *args):
        """
        V.set_has_transparency(bool)
        C++: void SetHasTransparency(bool t)"""
        ret = self._wrap_call(self._vtk_obj.SetHasTransparency, *args)
        return ret

    def set_interact_at_server(self, *args):
        """
        V.set_interact_at_server(bool)
        C++: void SetInteractAtServer(bool i)"""
        ret = self._wrap_call(self._vtk_obj.SetInteractAtServer, *args)
        return ret

    def set_is_widget(self, *args):
        """
        V.set_is_widget(bool)
        C++: void SetIsWidget(bool w)"""
        ret = self._wrap_call(self._vtk_obj.SetIsWidget, *args)
        return ret

    def set_transformation_matrix(self, *args):
        """
        V.set_transformation_matrix(Matrix4x4)
        C++: void SetTransformationMatrix(Matrix4x4 *m)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetTransformationMatrix, *my_args)
        return ret

    def set_type(self, *args):
        """
        V.set_type(WebGLObjectTypes)
        C++: void SetType(WebGLObjectTypes t)"""
        ret = self._wrap_call(self._vtk_obj.SetType, *args)
        return ret

    def set_visibility(self, *args):
        """
        V.set_visibility(bool)
        C++: void SetVisibility(bool vis)"""
        ret = self._wrap_call(self._vtk_obj.SetVisibility, *args)
        return ret

    def set_wireframe_mode(self, *args):
        """
        V.set_wireframe_mode(bool)
        C++: void SetWireframeMode(bool wireframe)"""
        ret = self._wrap_call(self._vtk_obj.SetWireframeMode, *args)
        return ret

    def is_visible(self):
        """
        V.is_visible() -> bool
        C++: bool isVisible()"""
        ret = self._vtk_obj.isVisible()
        return ret
        

    def is_widget(self):
        """
        V.is_widget() -> bool
        C++: bool isWidget()"""
        ret = self._vtk_obj.isWidget()
        return ret
        

    def is_wireframe_mode(self):
        """
        V.is_wireframe_mode() -> bool
        C++: bool isWireframeMode()"""
        ret = self._vtk_obj.isWireframeMode()
        return ret
        

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('id', 'GetId'), ('layer', 'GetLayer'),
    ('renderer_id', 'GetRendererId'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'id', 'layer', 'renderer_id'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(WebGLObject, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit WebGLObject properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['id', 'layer', 'renderer_id']),
            title='Edit WebGLObject properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit WebGLObject properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

